import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class DFT_IDFT extends Frame
{  public double currentX, currentY; // ݂̕`ʒu
   public DFT_IDFT()
   {  setSize(800,400);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public Complex[] DFT(Complex [] X, int Max)
   {  Complex[] Y= new Complex[Max+1];
      int k, n; double Pi=6.28318530717959;
      for(k = 0; k< Max; k++)
      { Y[k] = new Complex(0, 0); double KM = (double)k / (double)Max;
        for(n = 0; n < Max; n++)
            Y[k] = Y[k].add(X[n].mult(Complex.expJ(-Pi * n * KM)));
      }
      Y[Max] = Y[0];
      return Y;
  }
  public Complex[] IDFT(Complex [] X, int Max)
  {  Complex[] Y= new Complex[Max+1];
     int k, n; double Pi=6.28318530717959;
     for(k = 0; k< Max; k++)
      { Y[k] = new Complex(0, 0); double KM = (double)k / (double)Max;
        for(n = 0; n < Max; n++)
            Y[k] = Y[k].add(X[n].mult(Complex.expJ(Pi * n * KM)));
      }
      for(k = 0; k< Max;k++)  Y[k] = Y[k].div((double) Max);
      Y[Max] = Y[0];
      return Y;
  }

   public int Xpos(double X)
   {  return (int)(X*50)+100;}
   public int Ypos(double Y)
   {  return 200- (int)(Y*50);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }

   public void paint(Graphics g)
   { 
     int Max = 100;int i,k; boolean Flag = false;
     Complex [] X = new Complex[Max + 1];
     for(i = 0 ; i<= Max; i++)
     {  if(i>=30 && i<70) X[i]= new Complex(1,0); 
        else              X[i]= new Complex(0,0); 
     }
     Complex [] Y1 = DFT(X, Max);
     Complex [] Y2 = IDFT(Y1, Max);

     setTitle("DFT, IDFT");
     g.drawString("`gDFTIDFT",100,100);
     g.drawString("DFT",210,200);
     g.drawString("IDFT",210,300);
     
     g.setColor(new Color(0,0,255));
     
     Flag = false;
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02, X[k].R, Flag);
     Flag = false;
     g.setColor(new Color(255,0,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02+3.5, Y1[k].R/20-1, Flag);
     
     Flag = false;
     g.setColor(new Color(0,255,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k*0.02, Y2[k].R-2, Flag);
    
   } 
   public static void main(String[] args)
   {  Frame w = new DFT_IDFT();
      w.setVisible(true);
   }
}
